


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: ParsedCommand</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.application</a> ]
</div>

<h1>Coverage Summary for Class: ParsedCommand (com.dema.timeregistration.application)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">ParsedCommand</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (6/ 6)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (25/ 25)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.application;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import java.util.HashMap;
<i>4</i>&nbsp;import java.util.Map;
<i>5</i>&nbsp;import java.util.Optional;
<i>6</i>&nbsp;import java.util.Set;
<i>7</i>&nbsp;import java.util.stream.Collectors;
<i>8</i>&nbsp;
<i>9</i>&nbsp;/**
<i>10</i>&nbsp; * Represents a parsed command with values for each of it&#39;s parameters
<i>11</i>&nbsp; */
<i>12</i>&nbsp;public class ParsedCommand {
<i>13</i>&nbsp;    private final Command command;
<b class="fc"><i>14</i>&nbsp;    private final Map&lt;Parameter, String&gt; values = new HashMap&lt;&gt;();</b>
<i>15</i>&nbsp;
<b class="fc"><i>16</i>&nbsp;    public ParsedCommand(Command command) {</b>
<b class="fc"><i>17</i>&nbsp;        this.command = command;</b>
<b class="fc"><i>18</i>&nbsp;    }</b>
<i>19</i>&nbsp;
<i>20</i>&nbsp;    public Command getCommand() {
<b class="fc"><i>21</i>&nbsp;        return command;</b>
<i>22</i>&nbsp;    }
<i>23</i>&nbsp;
<i>24</i>&nbsp;    public void addParsedParameter(Parameter parameter, String value) {
<b class="fc"><i>25</i>&nbsp;        values.put(parameter, value);</b>
<b class="fc"><i>26</i>&nbsp;    }</b>
<i>27</i>&nbsp;
<i>28</i>&nbsp;    public Optional&lt;String&gt; getOptional(String name) {
<b class="fc"><i>29</i>&nbsp;        Optional&lt;Parameter&gt; param = values</b>
<b class="fc"><i>30</i>&nbsp;                .keySet()</b>
<b class="fc"><i>31</i>&nbsp;                .stream()</b>
<b class="fc"><i>32</i>&nbsp;                .filter(p -&gt; p.getName().equals(name))</b>
<b class="fc"><i>33</i>&nbsp;                .findFirst();</b>
<i>34</i>&nbsp;
<b class="fc"><i>35</i>&nbsp;        return param.map(values::get);</b>
<i>36</i>&nbsp;    }
<i>37</i>&nbsp;
<i>38</i>&nbsp;    public String get(String name) {
<b class="fc"><i>39</i>&nbsp;        Parameter parameter = values</b>
<b class="fc"><i>40</i>&nbsp;                .keySet()</b>
<b class="fc"><i>41</i>&nbsp;                .stream()</b>
<b class="fc"><i>42</i>&nbsp;                .filter(p -&gt; p.getName().equals(name))</b>
<b class="fc"><i>43</i>&nbsp;                .findFirst().orElseThrow(() -&gt; new IllegalStateException(&quot;Parsed command does not contain required parameter with keyword &quot; + name));</b>
<i>44</i>&nbsp;
<b class="fc"><i>45</i>&nbsp;        return values.get(parameter);</b>
<i>46</i>&nbsp;    }
<i>47</i>&nbsp;
<i>48</i>&nbsp;    public Set&lt;Parameter&gt; getMissingParamters() {
<b class="fc"><i>49</i>&nbsp;        return command</b>
<b class="fc"><i>50</i>&nbsp;                .getParameters()</b>
<b class="fc"><i>51</i>&nbsp;                .stream()</b>
<b class="fc"><i>52</i>&nbsp;                .filter(Parameter::isRequired)</b>
<b class="fc"><i>53</i>&nbsp;                .filter(p -&gt; !values.containsKey(p))</b>
<b class="fc"><i>54</i>&nbsp;                .collect(Collectors.toSet());</b>
<i>55</i>&nbsp;    }
<i>56</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
